'' VGA_Text_Hires
{
  VGA Text Driver with 64x25 characters mixed together from other sources

  1. 'Modified Parallax's file to use 16x16 4-color tiles and display custom tiles
  2. Cards from 'Copyright 2007 Raymond Allen    

  experimental: made by ChrisMicro 2009
}

CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  
    'number of custom 16x16 characters              
  nuchars = 80   '!!!!! you must have the correct # here for alignment later

  'for display
  cols = 64        'characters are 16 pixels wide
  rows = 48        '           and 32 pixels tall   (2 16-pixel rows per character)
  tiles = cols * rows


  display_base = $6000
  'screensize = cols * rows
  'lastrow = screensize - cols
  'tv_count = 14
  vga_params = 21 

  nCardsInDeck=52

  
VAR

  'variables for display
  long  col, row, color, flag
  long  array[tiles/2]                  
  long  colors[8 * 2]
    'for custom characters
  word user_charbase

    'for drawing buttons
  word ptr
  byte boxcolor

OBJ

  vga :  "VGA_1024x768_Tile_Driver_With_Cursor"  


PUB start(basepin) : okay 

'' start vga driver
  setcolors(@palette)  
  okay :=vga.start(basepin, @array, @colors, 0,0,0)
  clearScreen
  
PRI stopVGA

'' Stop terminal - frees a cog

  vga.stop

PUB box(left,top,width,height) | x, y, i

  ptr := top * cols + left
  boxchr($0)
  repeat i from 1 to width
    boxchr($C)
  boxchr($8)
  repeat i from 1 to height
    ptr := (top + i) * cols + left
    boxchr($A)
    ptr += width
    boxchr($B)
  ptr := (top + height + 1) * cols + left
  boxchr($1)
  repeat i from 1 to width
    boxchr($D)
  boxchr($9)

PRI boxchr(c): i

  array.word[ptr++] := $8000 + c << 6 + boxcolor' boxcolor << 10 + $200 + c


PUB str(stringptr)

'' Print a zero-terminated string
  repeat strsize(stringptr)
    out(byte[stringptr++])


PUB dec(value) | i

'' Print a decimal number

  if value < 0
    -value
    out("-")

  i := 1_000_000_000

  repeat 10
    if value => i
      out(value / i + "0")
      value //= i
      result~~
    elseif result or i == 1
      out("0")
    i /= 10


PUB hex(value, digits)

'' Print a hexadecimal number

  value <<= (8 - digits) << 2
  repeat digits
    out(lookupz((value <-= 4) & $F : "0".."9", "A".."F"))


PUB bin(value, digits)

'' Print a binary number

  value <<= 32 - digits
  repeat digits
    out((value <-= 1) & 1 + "0")


PUB out(c) | i, k

'' Output a character
''
''     $00 = clear screen
''     $01 = home
''     $05 = USER 1-BIT CHARACTER
''     $08 = backspace
''     $09 = tab (8 spaces per)
''     $0A = set X position (X follows)
''     $0B = set Y position (Y follows)
''     $0C = set color (color follows)
''     $0D = return
''  others = printable characters

  case flag
    $00: case c
           $00: clearScreen
           $01: col := row := 0
           $05: flag:=c
           $08: if col
                  col--
           $09: repeat
                  print(" ")
                while col & 7
           $0A..$0C: flag := c
                     return
           $0D: newline
           other: print(c)
    $0A: col := c // cols 
    $0B: row := (c*2) // rows
    $0C: color := c & 7
    $05: uPrint(c,row,col++)
         if ++col == cols
           newline
  flag := 0

PUB clearScreen
  wordfill(@array, $8000 + $20 << 6, tiles)
  col := row := 0

PUB print(c) |i,k
  k := color << 1 + c & 1
  i := $8000 + (c & $FE) << 6 + k
  array.word[row * cols + col] := i           '(color << 1 + c & 1) << 10 + $200 + c & $FE
  array.word[(row+1) * cols + col] :=i|$40    ':= (color << 1 + c & 1) << 10 + $200 + c & $FE +1 
  if ++col == cols
    newline

PRI uPrint(c,ncol,nrow)
  uPrintTop(c,ncol,nrow)
  uPrintBottom(c,ncol,nrow+1)
  
PRI uPrintTop(c,ncol,nrow)|i,k
  'print top part of a character
  k := color << 1 + c & 1
  i := user_charbase + (c & $FE) << 6 + k
  array.word[nrow * cols + ncol] := i'user_charbase + (c<<6)  + color'(color << 1 + c & 1) << 10 + user_charbase>>6 + c & $FE

PRI uPrintBottom(c,ncol,nrow)|i,k
  'print bottom part of a character
    k := color << 1 + c & 1
  i := user_charbase + (c & $FE) << 6 + k
  array.word[nrow * cols + ncol] := i+$40'user_charbase + (c<<6)  + color+$40'(color << 1 + c & 1) << 10 + user_charbase>>6 + c & $FE +1 
   
PRI newline | i

  col := 0
  if (row += 2) == rows
    row -= 2
    'scroll lines
    repeat i from 0 to rows-3
      wordmove(@array.word[i*cols], @array.word[(i+2)*cols], cols)
    'clear new line
    wordfill(@array.word[(rows-2)*cols], $8000 + $20 << 6, cols<<1)
PUB setcolors(colorptr) | i, fore, back

'' Override default color palette
'' colorptr must point to a list of up to 8 colors
'' arranged as follows (where r, g, b are 0..3):
''
''               fore   back
''               ------------
'' palette  byte %%rgb, %%rgb     'color 0
''          byte %%rgb, %%rgb     'color 1
''          byte %%rgb, %%rgb     'color 2
''          ...

  repeat i from 0 to 7
    fore := byte[colorptr][i << 1] << 2
    back := byte[colorptr][i << 1 + 1] << 2
    colors[i << 1]     := fore << 24 + back << 16 + fore << 8 + back
    colors[i << 1 + 1] := fore << 24 + fore << 16 + back << 8 + back

    

DAT
                        '        fore   back
                        '         RGB    RGB
palette                 byte    %%333, %%001    '0    white / dark blue
                        byte    %%330, %%110    '1   yellow / brown
                        byte    %%202, %%000    '2  magenta / black
                        byte    %%111, %%333    '3     grey / white
                        byte    %%033, %%011    '4     cyan / dark cyan
                        byte    %%020, %%232    '5    green / gray-green
                        byte    %%100, %%311    '6      red / pink
                        byte    %%033, %%003    '7     cyan / blue

